<?php
namespace GartentechnikCom;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Register {
	static private $instances = [];
	static private $domain = '';
	static private $current_path = '';
	static private $zeige_gtcom = false;
	static private $virtueller_post = null;
	static private $ist_eine_suche = false;
	static private $suchquery = '';
	static private $ignoriere_the_posts_hook = false;
	static private $ist_such_autovervollstaendigung = false;
	static private $wp_admin_topmenue = [];
	static private $app = null;
	static private $plugin_version = '0';
	static private $api_version = '0';
	
	# VOID
	public static function init($domain, $current_path, $app, $plugin_version, $api_version) {
		self::$domain = $domain;
		self::$current_path = $current_path;
		self::$app = $app;
		self::$plugin_version = $plugin_version;
		self::$api_version = $api_version;
	}
	# ARRAY || NULL
	public static function gib_widget_produktansicht($id) {
		return self::$app->gib_widget_produktansicht($id);
	}
	# STRING
	public static function gib_plugin_version() {
		return self::$plugin_version;
	}
	# STRING
	public static function gib_api_version() {
		return self::$api_version;
	}
	# OBJ
	public static function get_wp_menue() {
		$instance = @self::$instances['menue'];
		if(is_null($instance)) {
			$instance = new \GartentechnikCom\WP\Menue();
			self::$instances['menue'] = $instance;
		}
		return $instance;
	}
	# STRING
	public static function erzeuge_link($typ, $element) {
		$instance = @self::$instances['linkerzeuger'];
		if(is_null($instance)) {
			$instance = new \GartentechnikCom\Linkerzeuger();
			self::$instances['linkerzeuger'] = $instance;
		}
		return $instance->erzeuge_link($typ, $element);
	}
	# STRING
	public static function gib_aktuellen_pfad() {
		return self::$current_path;
	}
	# BOOLEAN
	public static function zeige_gtcom($val = null) {
		if(!is_null($val)) self::$zeige_gtcom = $val;
		
		return self::$zeige_gtcom;
	}
	# OBJ || NULL
	public static function virtueller_post($post = null) {
		if(!is_null($post)) self::$virtueller_post = $post;
		
		return self::$virtueller_post;
	}
	# BOOLEAN
	public static function ist_eine_suche($val = null) {
		if(!is_null($val)) self::$ist_eine_suche = $val;
		
		return self::$ist_eine_suche;
	}
	# STRING
	public static function suchquery($val = null) {
		if(!is_null($val)) self::$suchquery = $val;
		
		return self::$suchquery;
	}
	# BOOLEAN
	public static function ignoriere_the_posts_hook($val = null) {
		if(!is_null($val)) self::$ignoriere_the_posts_hook = $val;
		
		return self::$ignoriere_the_posts_hook;
	}
	# BOOLEAN
	public static function ist_such_autovervollstaendigung($val = null) {
		if(!is_null($val)) self::$ist_such_autovervollstaendigung = $val;
		
		return self::$ist_such_autovervollstaendigung;
	}
	# ARRAY
	public static function wp_admin_topmenue($array = null) {
		if(!is_null($array)) self::$wp_admin_topmenue = $array;
		
		return self::$wp_admin_topmenue;
	}
}
?>
