<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

{# Ist bereits der init-Context

    if(\GartentechnikCom\Register::ist_such_autovervollstaendigung()) {
		add_filter('the_posts', function($wp_posts) use ($app) {
			gartentechnik_com_debug('the_posts_filter_start');
			$suchstring = sanitize_text_field(stripcslashes($_POST['s']));
			$trefferListe = $app->gib_suchergebnisse($suchstring);
			$posts = array_splice($wp_posts, 0, 3);
			foreach ($trefferListe as $treffer) {
				$post = new stdClass;
				$post->post_content = '-';
				$post->post_title = $treffer['titel'];
				$post->post_name = $treffer['link'];
				
				$post->ID = floor(mt_rand()) * -1;
				$post->post_author = 1;
				$post->post_date = current_time('mysql');
				$post->post_date_gmt = current_time('mysql', 1);
				$post->post_excerpt = '';
				$post->post_status = 'publish';
				$post->comment_status = 'closed';
				$post->ping_status = 'closed';
				$post->post_password = '';
				$post->to_ping = '';
				$post->pinged = '';
				$post->modified = $post->post_date;
				$post->modified_gmt = $post->post_date_gmt;
				$post->post_content_filtered = '';
				$post->post_parent = 0;
				$post->guid = get_home_url('/' . $post->post_name);
				$post->menu_order = 0;
				$post->post_type = 'page';
				$post->post_mime_type = '';
				$post->comment_count = 0;
				
				array_push($posts, $post);
			}
			gartentechnik_com_debug('the_posts_filter_end');
			return $posts;
		}, 20, 1);
	}
}
?>