<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

{# Ist bereits der init-Context

	$gartentechnik_com_produktwidget_datenabruf = function() {
		gartentechnik_com_debug('produktwidget_abruf_start');
		$id_zuordnungen = array();
		$ids = array();
		$i = 0;
		while(true) {
			if(!array_key_exists('id' . $i, $_POST)) break;

			$id_valid = sanitize_text_field($_POST['id' . $i]);
			$widget_id_valid = sanitize_text_field($_POST['widget_id' . $i]);

			$id_zuordnungen[$id_valid] = $widget_id_valid;
			$ids['id' . $i] = $id_valid;
			$i++;
		}
		$produkte = \GartentechnikCom\Register::gib_widget_produktansicht($ids);
		$daten = array();
		if($produkte) {
			foreach($produkte as $p) {
				$widget_id = $id_zuordnungen[$p['id']];
				if(!$widget_id) continue;
				
				$p['widget_id'] = $widget_id;
				array_push($daten, $p);
			}
		}
		echo json_encode($daten);
		gartentechnik_com_debug('produktwidget_abruf_end');
		
		// Don't forget to exit!
		exit;
	};
	add_action('wp_ajax_gartentechnik_com_produktwidget_datenabruf', $gartentechnik_com_produktwidget_datenabruf, 20, 0);
	add_action('wp_ajax_nopriv_gartentechnik_com_produktwidget_datenabruf', $gartentechnik_com_produktwidget_datenabruf, 20, 0);
}
?>