<?php if (!defined('ABSPATH')) exit; // Exit if accessed directly ?>

<p>
	<label
		for="<?php echo $this->get_field_id('title'); ?>"
	>
		Titel:
	</label>
	<input
		class="widefat"
		id="<?php echo $this->get_field_id('title'); ?>"
		name="<?php echo $this->get_field_name('title'); ?>"
		type="text"
		value="<?php echo esc_attr($title); ?>"
	/>
</p>
<p>
	<label for="<?php echo $this->get_field_id('text'); ?>">Wenn nicht genügend Angebote vorhanden sind, soll die Liste mit beliebten Produkte aufgefüllt
		werden?</label>
	<select
		class='widefat'
		id="<?php echo $this->get_field_id('angebote_auffuellen'); ?>"
		name="<?php echo $this->get_field_name('angebote_auffuellen'); ?>"
		type="text"
	>
		<option value='0'<?php echo ($angebote_auffuellen == '0') ? 'selected' : ''; ?>>
			Nein
		</option>
		<option value='1'<?php echo ($angebote_auffuellen == '1') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 1 Produkt enthält
		</option>
		<option value='2'<?php echo ($angebote_auffuellen == '2') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 2 Produkte enthält
		</option>
		<option value='3'<?php echo ($angebote_auffuellen == '3') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 3 Produkte enthält
		</option>
		<option value='4'<?php echo ($angebote_auffuellen == '4') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 4 Produkte enthält
		</option>
		<option value='5'<?php echo ($angebote_auffuellen == '5') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 5 Produkte enthält
		</option>
		<option value='6'<?php echo ($angebote_auffuellen == '6') ? 'selected' : ''; ?>>
			Ja, auffüllen, bis die Liste 6 Produkte enthält
		</option>
	</select>
</p>
<p>
	<label for="<?php echo $this->get_field_id('text'); ?>">Wie viele Zeilen an Angeboten sollen angezeigt werden?</label>
	<select
		class='widefat'
		id="<?php echo $this->get_field_id('zeilen_angebote'); ?>"
		name="<?php echo $this->get_field_name('zeilen_angebote'); ?>"
		type="text"
	>
		<option value='1'<?php echo ($zeilen_angebote == '1') ? 'selected' : ''; ?>>
			1
		</option>
		<option value='2'<?php echo ($zeilen_angebote == '2') ? 'selected' : ''; ?>>
			2
		</option>
		<option value='3'<?php echo ($zeilen_angebote == '3') ? 'selected' : ''; ?>>
			3
		</option>
		<option value='4'<?php echo ($zeilen_angebote == '4') ? 'selected' : ''; ?>>
			4
		</option>
		<option value='5'<?php echo ($zeilen_angebote == '5') ? 'selected' : ''; ?>>
			5
		</option>
		<option value='6'<?php echo ($zeilen_angebote == '6') ? 'selected' : ''; ?>>
			6
		</option>
	</select>
</p>
<p>
	<label
		for="<?php echo $this->get_field_id('benutzerdefiniertes_css'); ?>"
	>
		Eigenes CSS definieren:
	</label><br>
	<textarea
		id="<?php echo $this->get_field_id('benutzerdefiniertes_css'); ?>"
		name="<?php echo $this->get_field_name('benutzerdefiniertes_css'); ?>"
		style="width: 100%;height: 300px;"
	><?php echo esc_attr($benutzerdefiniertes_css); ?></textarea>
</p>
